//Menu.js

var MainMenuOptions=new Array("Status","Inventory","Equip","Options","Switch","Journal","Return");
var CurrentMainOption=0;
var seconds=0;
var minutes=0;
var hours=0;
var w=0;
var startAt=0;


var arrow=LoadImage("arrow.png");
function PressKey()
{
	while(AreKeysLeft())
	{
		switch (GetKey())
		{
			case KEY_DOWN: return KEY_DOWN; break;
			case KEY_UP: return KEY_UP; break;
			case KEY_Z: return KEY_Z; break;
			case KEY_X: return KEY_X; break;
		}
	}
	
}
function drawText(font,x,y,text)
{
	var mask = font.getColorMask();
	font.setColorMask(black);
	font.drawText(x-1,y-1,text);
	font.drawText(x+1,y-1,text);
	font.drawText(x+1,y+1,text);
	font.drawText(x-1,y+1,text);
	font.setColorMask(mask);
	font.drawText(x,y,text);
}
function MainMenu()
{
	var time=GetTime()+250;
	var key;
	ClearKeyQueue();
	Rectangle(0,0,320,240,black);
	ws.drawWindow(249,29,63,97);
	ws.drawWindow(249,134,63,54);
	ws.drawWindow(8,29,234,203);
	ws.drawWindow(8,8,304,14);
	ws.drawWindow(249,196,63,36);
	drawText(font2,13,0,"Help");
	drawText(font2,254,126,"Misc.");
	var numActivated=0;
	for(var i=0;i<8;i++)
	{
		if(Char[i].activated)
			numActivated++;
	}
	for(var i=0;i<numActivated;i++)
	{
		font2.setColorMask(redMenu);
		drawText(font2,38,48+i*49+2,"HP:");
		font2.setColorMask(blueMenu);
		drawText(font2,38,60+i*49+2,"MP:");
		font2.setColorMask(cyanMenu);
		drawText(font2,140,48+i*49+2,"Next Lv:");
		font2.setColorMask(greenMenu);
		drawText(font2,140,60+i*49+2,"Total XP:");
		font2.setColorMask(white);
	}
	drawMainMenu();
	menuImg=GrabImage(0,0,320,240);
	while (true)
	{
		startAt=0;
		seconds=Floor((g_TimePlayed+GetTime()-g_TimeStart)/1000);
		minutes=Floor(seconds/60);
		hours=Floor(minutes/60);
		menuImg.blit(0,0);
		drawText(font2,12,10,drawHelp());
		drawStatusParty();
		drawMainMenu();
		drawMiscStuff();
		FlipScreen();
		key=PressKey();
		if(time<GetTime())
		{
			if(key==KEY_UP && CurrentMainOption>0)
					CurrentMainOption--;
			else if(key==KEY_DOWN && CurrentMainOption<MainMenuOptions.length-1)
					CurrentMainOption++;
			else if(key==KEY_Z)
			{
				if(CurrentMainOption==0)
					statusMenu();
				//items
				else if(CurrentMainOption==1)
				{
					
				}
				//equip
				else if(CurrentMainOption==2)
				{
					selectChar();
				}
				//options
				else if(CurrentMainOption==3)
				{
					//option menu...
				}
				else if(CurrentMainOption==4)
					switchChar();
				else if(CurrentMainOption==5)
					lookAtJournal();
				else
					return;
				time=GetTime()+100;
			}
			else if (key==KEY_X)
				return;
		}
	}
}

function selectChar()
{
	var numActivated=0;
	var isMissing=[true,true,true,true,true,true,true,true];
	for(var i=0;i<8;i++)
	{
		if(Char[i].activated)
			isMissing[i]=false;
	}
	for(var i=0;i<8;i++)
	{
		if(Char[i].activated)
			numActivated++;
	}
	var characterChosen=0;
	time=GetTime()+100;
	var characterPicked=0;
	function determineCharacter()
	{
		//check character.
		for(var i=0;i<8;i++)
		{
			//if the character currently chosen is equal to the number of i...
			if(characterChosen+startAt==i)
			{
				//then,the character picked is equal to i.
				characterPicked=i;
				//but! to check for if characters in between dont exist...
				//for every character up to i,check to see if its activated,if not,subtract 1.
				var offset=0;
				for(var j=0;j<=i+offset;j++)
				{
					if(isMissing[j])
					{
						characterPicked++;
						offset++;
					}
				}
				return Char[characterPicked].name;
			}
		}
	}
	var key;
	while(true)
	{
		seconds=Floor((g_TimePlayed+GetTime()-g_TimeStart)/1000);
		minutes=Floor(seconds/60);
		hours=Floor(minutes/60);
		menuImg.blit(0,0);
		font2.drawText(12,10,"Choose "+determineCharacter()+"?");
		drawStatusParty(startAt);
		drawMiscStuff();
		selectRect.blit(9,30+characterChosen*49);
		key=PressKey();
		if(key==KEY_UP)
		{
			characterChosen--;
			if(characterChosen<0)
			{
				characterChosen=0;
				if(startAt>0)
					startAt--;
			}
		}
		else if(key==KEY_DOWN&&characterChosen<numActivated-1)
		{
			characterChosen++;
			if(characterChosen>3)
			{
				characterChosen=3;
				if(startAt<numActivated-4)
					startAt++;
			}
		}
		else if(key==KEY_Z)
			return characterPicked;
		else if(key==KEY_X)
			return -1;
		FlipScreen();
	}
}

function drawMainMenu()
{
	for (var i=0;i<7;i++)
	{
		font.drawText(255,(i*12)+35,MainMenuOptions[i]);
	}
}

function drawMiscStuff()
{
	arrow.blit(248,(CurrentMainOption*12)+37);
	font.setColorMask(cyanMenu);
	font.drawText(253,7*12+53,"Time:");
	font.setColorMask(white);
	var numTime="";
	if(hours<10)
		numTime="0"+hours;
	else
		numTime=hours;
	numTime+=":";
	if(minutes%60<10)
		numTime+="0"+minutes%60;
	else
		numTime+=minutes%60;
	numTime+=":";
	if(seconds%60<10)
		numTime+="0"+seconds%60;
	else
		numTime+=seconds%60;
	drawText(font2,258,150,numTime);
	font.setColorMask(cyanMenu);
	font.drawTextBox(253,7*12+77,50,13,0,"Gold:");
	font2.setColorMask(yellowMenu);
	drawText(font2,301,7*12+88,"G");
	font2.setColorMask(white);
	font.setColorMask(white);
	w=font2.getStringWidth(g_Gold);
	drawText(font2,301-w,7*12+88,g_Gold);
	emptySphere.blit(253,200);
	for(var i=0;i<3;i++)
	{
		if(i<g_NumSpheres)
			fullSphere.blit(253+i*20,200);
	}
	for(var i=3;i<6;i++)
	{
		if(i<g_NumSpheres)
			fullSphere.blit(253+(i-3)*20,214);
	}
}

function drawHelp()
{
	if(CurrentMainOption==0)
		return "View statistics and current status.";
	else if(CurrentMainOption==1)
		return "View and/or use items you have.";
	else if(CurrentMainOption==2)
		return "Change a character's equipped gear.";
	else if(CurrentMainOption==3)
		return "Save the game or change the game options.";
	else if(CurrentMainOption==4)
		return "Switch two party members.";
	else if(CurrentMainOption==5)
		return "A log of the events that have happened.";
	else if(CurrentMainOption==6)
		return "Quit the menu and return to game.";
}

function drawStatusParty(someNum)
{
	var percent,width,percentmp,widthmp,length,lengthmp;
	var numberActivated=-1;
	var startAt;
	if(!someNum)
		startAt=0;
	else
		startAt=someNum;
	for(j=0;j<8;j++)
	{
		if(Char[j].activated)
		{
			numberActivated++;
			if(numberActivated-startAt>3)
				return;
			if(numberActivated>=startAt)
			{
				Char[j].faceset.blit(12,33+(numberActivated-startAt)*49);
				font.drawText(38,33+(numberActivated-startAt)*49+2,Char[j].name + " Lv"+Char[j].Stats.Level);
				drawText(font2,59,48+(numberActivated-startAt)*49+2,Char[j].Stats.HP+"/"+Char[j].Stats.maxHP);
				drawText(font2,59,60+(numberActivated-startAt)*49+2,Char[j].Stats.MP+"/"+Char[j].Stats.maxMP);
				drawText(font2,200,48+(numberActivated-startAt)*49+2,nextLvExp[Char[j].Stats.Level]);
				drawText(font2,200,60+(numberActivated-startAt)*49+2,Char[j].Exp);
			}
		}
	}
}
function statusMenu()
{
	var index=selectChar();
	if(index==-1)
		return;
	var faceset=Char[index].facesetFull;
	var spriteset=LoadSpriteset(Char[index].name+".rss");
	var indexSprite=0;
	var width=spriteset.images[0].width;
	var height=spriteset.images[0].height;
	var color=CreateColor(255,255,255,255);
	var interval=-2.5;
	var maxAlpha=255+interval;
	var minAlpha=0-interval;
	Rectangle(0,0,320,240,black);
	ws.drawWindow(8,8,48,48);
	ws.drawWindow(64,8,108,48);
	ws.drawWindow(8,64,304,168);
	faceset.blit(8,8);
	font.setColorMask(cyanMenu);
	font.drawText(18,70,"Next Level:");
	font.drawText(18,146,"Speed:");
	font2.setColorMask(blueMenu);
	drawText(font2,66,40,"MP:");
	font2.setColorMask(redMenu);
	font.setColorMask(redMenu);
	drawText(font2,66,28,"HP:");
	font.drawText(18,98,"Attack:");
	font.drawText(18,110,"Defense:");
	font.setColorMask(yellowMenu);
	font.drawText(18,122,"Magic Attack:");
	font.drawText(18,134,"Magic Defense:");
	font.setColorMask(greenMenu);
	font.drawText(18,82,"Total Experience:");
	font.setColorMask(white);
	font2.setColorMask(white);
	drawText(font2,87,28,Char[index].Stats.HP+"/"+Char[index].Stats.maxHP);
	drawText(font2,87,40,Char[index].Stats.MP+"/"+Char[index].Stats.maxMP);
	drawText(font2,73,99,Char[index].Stats.Attack);
	drawText(font2,73,111,Char[index].Stats.Defense);
	drawText(font2,113,123,Char[index].Stats.SpecialAttack);
	drawText(font2,113,135,Char[index].Stats.SpecialDefense);
	drawText(font2,60,147,Char[index].Stats.Speed);
	drawText(font2,124,71,nextLvExp[Char[index].Stats.Level]);
	drawText(font2,124,83,Char[index].Exp);
	wsImg=GrabImage(0,0,320,240);
	var delay=250;
	var lastTime=GetTime();
	var key;
	while(true)
	{
		wsImg.blit(0,0);
		font.drawText(66,10,Char[index].name+" "+Char[index].lastName);
		spriteset.images[spriteset.directions[2].frames[indexSprite].index].blitMask(32-width/2,32-height/2,color);
		color.alpha+=interval;
		if((color.alpha<=minAlpha&&interval<0)||(color.alpha>=maxAlpha&&interval>0))
			interval=-interval;
		if(delay+lastTime<GetTime())
		{
			lastTime=GetTime();
			indexSprite++;
			if(indexSprite==4)
				indexSprite=0;
		}
		key=PressKey();
		if(key==KEY_X)
			return;
		FlipScreen();
	}
}
function switchChar()
{
	var index=selectChar();
	if(index==-1)
		return;
	var isMissing=[true,true,true,true,true,true,true,true];
	var numActivated=0;
	for(var i=0;i<8;i++)
	{
		if(Char[i].activated)
		{
			isMissing[i]=false;
			numActivated++;
		}
	}
	var copyOfChar=new character();
	var characterPicked=0;
	function determineCharacter()
	{
		//check character.
		for(var i=0;i<8;i++)
		{
			//if the character currently chosen is equal to the number of i...
			if(characterChosen+startAt==i)
			{
				//then,the character picked is equal to i.
				characterPicked=i;
				//but! to check for if characters in between dont exist...
				//for every character up to i,check to see if its activated,if not,subtract 1.
				var offset=0;
				for(var j=0;j<=i+offset;j++)
				{
					if(isMissing[j])
					{
						characterPicked++;
						offset++;
					}
				}
				return Char[characterPicked].name;
			}
		}
	}
	var indexOffset=index;
	for(var j=0;j<=index;j++)
	{
		if(isMissing[j])
			indexOffset--;
	}
	var characterChosen=indexOffset-startAt;
	while(true)
	{
		seconds=Floor((g_TimePlayed+GetTime()-g_TimeStart)/1000);
		minutes=Floor(seconds/60);
		hours=Floor(minutes/60);
		menuImg.blit(0,0);
		font2.drawText(12,10,"Switch "+Char[index].name+" with "+determineCharacter()+"?");
		drawStatusParty(startAt);
		drawMiscStuff();
		if(indexOffset-startAt>-1&&indexOffset-startAt<4)
			selectRect.blitMask(9,30+(indexOffset-startAt)*49,redMenu);
		selectRect.blit(9,30+characterChosen*49);
		key=PressKey();
		if(key==KEY_DOWN&&characterChosen+startAt<numActivated)
		{
			characterChosen++;
			if(characterChosen>3)
			{
				characterChosen=3;
				if(startAt<numActivated-4)
					startAt++;
			}
		}
		else if(key==KEY_UP)
		{
			characterChosen--;
			if(characterChosen<0)
			{
				characterChosen=0;
				if(startAt>0)
					startAt--;
			}
		}
		else if(key==KEY_Z)
		{
			copyOfChar=Char[index];
			Char[index]=Char[characterPicked];
			Char[characterPicked]=copyOfChar;
			return;
		}
		else if(key==KEY_X)
			return;
		FlipScreen();
	}
}
function lookAtJournal()
{
	Rectangle(0,0,320,240,black);
	ws.drawWindow(8,8,105,224);
	ws.drawWindow(120,8,192,48);
	ws.drawWindow(120,63,192,169);
	font.setColorMask(greenMenu);
	font.drawText(26,12,"ENTRIES:");
	font.setColorMask(white);
	var count=0;
	for(var i=0;i<8;i++)
	{
		if(Char[i].activated)
			count++;
	}
	count=(8*24-count*24)*0.5;
	var countTwo=-1;
	wsImg=GrabImage(0,0,320,240);
	var curr=1;
	var key;
	var offset=0;
	var entryOffset=0;
	var numOfEntries=journal.getNumEntries();
	while(true)
	{
		journal.setEntryNew(curr-1+entryOffset);
		wsImg.blit(0,0);
		for(var i=0;i<8;i++)
		{
			if(journal.journalEntries[curr-1][5][i])
			{
				countTwo++;
				(Char[i].name==journal.getEntryWriter(curr-1+entryOffset)) ? Char[i].faceset.blit(120+count+24*i,8) :	Char[i].faceset.blitMask(120+count+24*countTwo,8,darkGray);
			}
		}
		countTwo=-1;
		for(var i=0;i<17;i++)
		{
			if(journal.getEntryTitle(i+entryOffset))
			{
				font.drawTextBox(16,25+i*12,97,12,0,journal.getEntryTitle(i+entryOffset));
				if(journal.getEntryNew(i+entryOffset))
					newImg.blit(87,25+i*12);
			}
		}
		arrow.blit(8,15+curr*12);
		if(font.getStringHeight(journal.getEntryText(curr-1+entryOffset)+"\n\n\t-"+journal.getEntryWriter(curr-1+entryOffset),186)>143)
		{
			font2.setColorMask(lightYellow);
			font2.drawText(145,220,"Hold Z+UP/DOWN to move");
			font2.setColorMask(white);
			arrowdown.blit(302,225);
			arrowup.blit(302,220);
		}
		if(numOfEntries>17&&numOfEntries>curr+entryOffset)
			arrowdown.blit(103,226);
		if(curr+entryOffset>1)
			arrowup.blit(94,226);
		font.setColorMask(lightYellow);
		font.drawTextBox(122,65,186,161,0,journal.getEntryTitle(curr-1+entryOffset));
		font.setColorMask(white);
		SetClippingRectangle(122,77,186,143);
		font.drawTextBox(122,77,186,145,offset,journal.getEntryText(curr-1+entryOffset)+"\n\n\t-"+journal.getEntryWriter(curr-1+entryOffset));
		SetClippingRectangle(0,0,320,240);
		key=PressKey();
		if(key==KEY_DOWN)
		{
			if(IsKeyPressed(KEY_Z))
			{
				if(offset>-font.getStringHeight(journal.getEntryText(curr-1+entryOffset)+"\n\n\t-"+journal.getEntryWriter(curr-1+entryOffset),186)+143)
					offset-=13;
			}
			else if(curr+entryOffset<numOfEntries)
			{
				if(curr<17)
					curr++;
				else
					entryOffset++;
				offset=0;
			}
		}
		else if(key==KEY_UP)
		{
			if(IsKeyPressed(KEY_Z))
			{
				if(offset<0)
					offset+=13;
			}
			else if(curr>1)
			{
				curr--;
				offset=0;
			}
			else if(entryOffset>0)
				entryOffset--;
		}
		else if(key==KEY_X)
			return;
		FlipScreen();
	}
}