function Skill(name,pwr,heal,ele,mp,lrnd,trgt,numHits,effect)
{
	this.name=name;
	this.basePwr=pwr;
	this.heal=heal;
	this.element=ele;
	this.lvlLearned=lrnd;
	this.mp=mp;
	this.targets=trgt;
	this.numHits=numHits;
	if(!effect)
		this.effect="none";
	else
		this.effect=effect;
}

var Skills = {
	CrossSlash:		new Skill("Cross Slash",	50,	0,	"Normal",	2,	3,	"enemy",	1),
	Focus:		new Skill("Focus",		0,	0,	"Normal",	4,	7,	"self",	1,	"speed"),
	QuadSlash:		new Skill("Quad Slash",		25,	0,	"Normal",	6,	11,	"enemy",	4),
	FirstAid:		new Skill("First Aid",		0,	30,	"Heal",	12,	15,	"self",	1),
	PhoenixFlame:	new Skill("Phoenix Flame",	70,	0,	"Fire",	18,	20,	"enemy",	1),
	DecaSlash:		new Skill("Deca Slash",		7,	0,	"Normal",	20,	26,	"enemy",	12),
	LightningBlade:	new Skill("Lightning Blade",	75,	0,	"Lightning",18,	29,	"enemy",	1),
	Sharpen:		new Skill("Sharpen",		0,	0,	"Normal",	30,	51,	"self",	1,	"attack"),
	DarkMind: 		new Skill("Dark Mind",		100,	0,	"Dark",	30,	100,	"enemy",	1),
	Return:		new Skill("Return",		120,	0,	"Light",	35,	100,	"enemy",	1),
	
	Heal:			new Skill("Heal",			0,	20,	"Heal",	5,	0,	"player",	1),
	Barrier:		new Skill("Barrier",		0,	0,	"Status",	10,	0,	"player",	1,	"defense"),
	Cure:			new Skill("Cure",			0,	0,	"Status",	10,	10,	"player",	1,	"cureStatus"),
	Regenerate:		new Skill("Regenerate",		0,	5,	"Status",	12,	19,	"player",	1,	"regen"),
	Raise:		new Skill("Raise",		0,	0,	"Heal",	20,	22,	"player",	1,	"revive"),
	Revitalize:		new Skill("Revitalize",		0,	40,	"Heal",	30,	28,	"party",	1),
	CureAll:		new Skill("Cure All",		0,	0,	"Status",	10,	34,	"party",	1,	"cureStatus"),
	FullHeal:		new Skill("Full-Heal",		0,	60,	"Heal",	40,	40,	"player",	1),
	FullRevitalize:	new Skill("Full-Revitalize",	0,	80,	"Heal",	48,	45,	"party",	1),
	Dia:			new Skill("Dia",			120,	0,	"Light",	50,	50,	"enemy",	1),
	
	CrushFang: 		new Skill("Crush Fang",		15,	0,	"Normal",	2,	0,	"enemy",	1),
	DoubleKick:		new Skill("Double Kick",	30,	0,	"Normal",	4,	7,	"enemy",	1),
	Bite:			new Skill("Bite",			60,	0,	"Normal",	16,	21,	"enemy",	1),
	FireFang:		new Skill("Fire Fang",		70,	0,	"Fire",	20,	28,	"enemy",	1),
	Crunch:		new Skill("Crunch",		90,	0,	"Normal",	30,	36,	"enemy",	1),
	BeastTackle:	new Skill("Beast Tackle",	100,	0,	"Normal",	25,	40,	"enemy",	1),
	DragonFang:		new Skill("Dragon Fang",	120,	0,	"Fire",	50,	50,	"enemy",	1),
	
	AirBlade:		new Skill("Air Blade",		25,	0,	"Fire",	2,	0,	"enemy",	1),
	Lightning:		new Skill("Lightning",		25,	0,	"Ground",	4,	7,	"enemy",	1),
	IceStorm:		new Skill("Ice Storm",		50,	0,	"Water",	4,	14,	"enemy",	1),
	Eruption:		new Skill("Eruption",		60,	0,	"Air",	16,	21,	"enemy",	1),
	AquaMantle:		new Skill("Aqua Mantle",	60,	0,	"Electric",	20,	28,	"enemy",	1),
	Earthquake:		new Skill("Earthquake",		60,	0,	"Ground",	30,	36,	"enemy",	1),
	Storm:		new Skill("Storm",		60,	0,	"Air",	25,	40,	"enemy",	1),
	Tornado:		new Skill("Tornado",		60,	0,	"Air",	50,	50,	"enemy",	1),
	Freezer:		new Skill("Freezer",		90,	0,	"Ice",	25,	40,	"enemy",	1),
	LavaFlow:		new Skill("Lava Flow",		95,	0,	"Normal",	25,	40,	"enemy",	1),
	Tsunami:		new Skill("Tsunami",		100,	0,	"Normal",	25,	40,	"enemy",	1),
	GroundCrack:	new Skill("Ground Crack",	110,	0,	"Normal",	25,	40,	"enemy",	1),
	Indignation:	new Skill("Indignation",	200,	0,	"Normal",	25,	40,	"enemy",	1)
};