RequireScript("Skills.js");
RequireScript("bCharaFunctions.js");

function character()
{
	this.Name = "";
	this.Spriteset = LoadSpriteset("goblinbs.rss");
	this.Status = {
		Haste: false,
		Slow: false,
		Regen: false,
		Down: false,
		Poison: false,
		OK: true
	};
	this.Stats = {
		HP: 			0,
		MP: 			0,
		maxHP: 		0,
		maxMP: 		0,
		
		Attack: 		0,
		Defense: 		0,
		SpecialAttack: 	0,
		SpecialDefense: 	0,
		
		Evasion:		5,
		Level:		1,
		Speed: 		0
	};
	this.tempAttack = 1;
	this.tempSpecialAttack = 1;
	this.tempDefense = 1;
	this.tempSpecialDefense = 1;
	this.tempSpeed = 1;
	this.Exprate = 1;
	this.Exp = 0;
	this.party = false;
	this.activated = false;
	this.lastName="";
	this.Skills = [];
	this.command = ["Attack", 0];
	this.secondOption = "Magic";
	//BATTLE STUFF
	this.functions;
}


Char = new Array(8);

Char[0] = new character();
Char[0].Exprate = 1.5;
Char[0].secondOption = "Tech";
Char[0].party = true;
Char[0].activated = true;
Char[0].faceset = LoadImage("Zerohalf.png");
Char[0].facesetFull = LoadImage("Zero.png");
Char[0].Spriteset = LoadSpriteset("Zero.rss");
Char[0].Stats = {
	HP: 			30, //30
	MP: 			5, //5
	maxHP: 		30,
	maxMP: 		5,
	
	Attack: 		10,
	Defense: 		10,
	SpecialAttack: 	5,
	SpecialDefense: 	5,
	
	Evasion:		5,
	Level:		1,
	Speed: 		10
};
Char[0].name = "Zero";
Char[0].lastName="Nadarien";
Char[0].Skills=[Skills.CrossSlash, Skills.Focus, Skills.QuadSlash, Skills.FirstAid, Skills.PhoenixFlame, Skills.DecaSlash, Skills.LightningBlade, Skills.Sharpen, Skills.DarkMind, Skills.Return];

Char[1] = new character();
Char[1].Stats = {
	HP: 			25,
	MP: 			10,
	maxHP: 		25,
	maxMP: 		10,
	
	Attack: 		5,
	Defense: 		5,
	SpecialAttack: 	10,
	SpecialDefense: 	10,
	
	Evasion:		5,
	Level:		1,
	Speed: 		8
};
Char[1].faceset = LoadImage("Afainahalf.png");
Char[1].facesetFull = LoadImage("Afaina.png");
Char[1].name = "Afaina";
Char[1].lastName="Khairlan";
Char[1].Spriteset = LoadSpriteset("Afaina.rss");
Char[1].Skills=[Skills.Heal, Skills.Barrier, Skills.Cure, Skills.Regenerate, Skills.Raise, Skills.Revitalize, Skills.CureAll, Skills.FullHeal, Skills.FullRevitalize, Skills.Dia];

Char[2] = new character();
Char[2].secondOption = "Tech";
Char[2].Stats = {
	HP: 			35,
	MP: 			4,
	maxHP: 		35,
	maxMP: 		4,
	
	Attack: 		17,
	Defense: 		10,
	SpecialAttack: 	5,
	SpecialDefense: 	5,
	
	Evasion:		5,
	Level:		1,
	Speed: 		10
};
Char[2].Spriteset = LoadSpriteset("Papo.rss");
Char[2].faceset = LoadImage("Papohalf.png");
Char[2].facesetFull = LoadImage("Papo.png");
Char[2].name = "Papo";
Char[2].Skills=[Skills.CrushFang, Skills.DoubleKick, Skills.Focus, Skills.Bite, Skills.FireFang, Skills.Crunch, Skills.BeastTackle, Skills.DragonFang];

Char[3] = new character;
Char[3].Stats = {
	HP: 			30,
	MP: 			10,
	maxHP: 		30,
	maxMP: 		10,
	
	Attack: 		6,
	Defense: 		7,
	SpecialAttack: 	9,
	SpecialDefense: 	7,
	
	Evasion:		5,
	Level:		1,
	Speed: 		8
};
Char[3].faceset = LoadImage("Lysanderhalf.png");
Char[3].facesetFull = LoadImage("Lysander.png");
Char[3].name = "Lysander";
Char[3].lastName="Midgos";
Char[3].Spriteset = LoadSpriteset("Lysanderbs.rss");
Char[3].Skills=[Skills.AirBlade, Skills.Lightning, Skills.IceStorm, Skills.Eruption, Skills.AquaMantle, Skills.Earthquake, Skills.Storm];


/*Fireball: Event/4/20Fire/1
Quake: Event/4/25Ground/1
Water Spout: Event/6/25Water/1
Air Blade: 15/6/25Air/1-2
Lightning: 16/6/25Electric/1
Ice Storm: 17/30/50IceAll/1
Eruption: 20/32/60FireAll/1
Aqua Mantle: 21/34/60WaterAll/1
Earthquake: 24/30/60GroundAll/1
Tangle: 28/33/60GrassAll/1
Storm: 32/34/60ElectricAll/1
Tornado: 36/50/80AirAll/1
Freezer: 40/50/90IceAll/1-2
Lava Flow: 44/55/95FireAll/1-2
Tsunami: 47/55/100WaterAll/1-2
Ground Crack: 50/60/110GroundAll/1-2
Indignation: 60/60/200Electric/3
Leaf Storm: 65/65/120GrassAll/1-2*/

Char[4] = new character;
Char[4].Stats = 	{
	HP: 			25,
	MP: 			5,
	maxHP: 		25,
	maxMP: 		5,
	
	Attack: 		13,
	Defense: 		5,
	SpecialAttack: 	5,
	SpecialDefense: 	5,
	
	Evasion:		5,
	Level:		1,
	Speed: 		12
			};
Char[4].faceset = LoadImage("Chijihalf.png");
Char[4].facesetFull = LoadImage("Chiji.png");
Char[4].name = "Chiji";
Char[4].lastName="Asakura";
Char[4].Spriteset = LoadSpriteset("Lysanderbs.rss");
Char[4].skillbasepower = new Array(40,20,0,60,90,90,90,0,10,0,120);
Char[4].skilllvl = new Array(0,0,14,20,31,32,33,45,55,61,62);
Char[4].skillmpused = new Array(5,10,12,15,30,30,30,30,40,50,50);
Char[4].skillname = new Array("Light Spear","Wave",Skills.Focus,"Dark Spear","Fire Bolt","Lightning Bolt","Ice Bolt","Haste","Shuriken Storm","Ninja Power","Holy Lance");


/*
(Lv/MP/Power/Hits)
Light Spear: 0/5/40Light/1
Wave: 0/10/20All/1
Focus: 14/12/AttackUp
Dark Spear: 20/15/60Dark/1
Fire Bolt: 31/30/90Fire/1
Lightning Bolt: 32/30/90Electric/1
Ice Bolt: 33/30/90Ice/1
Haste: 45/30/DoubleHitNumber
Shuriken Storm: 55/40/10/15-20
Ninja Power: 61/50/SpeedAndAttackUp
Holy Lance: 62/50/120Light/1-2*/

Char[5] = new character;
Char[5].Stats = 	{
	HP: 			20,
	MP: 			10,
	maxHP: 		20,
	maxMP: 		10,
	
	Attack: 		7,
	Defense: 		5,
	SpecialAttack: 	5,
	SpecialDefense: 	5,
	
	Evasion:		5,
	Level:		1,
	Speed: 		12
			};
Char[5].faceset = LoadImage("Theloniushalf.png");
Char[5].facesetFull = LoadImage("Thelonius.png");
Char[5].name = "Thelonius";
Char[5].Spriteset = LoadSpriteset("Lysanderbs.rss");
Char[5].skillbasepower = new Array(25,25,50,60,60,60,60,60,60,90,95,100,110,200,120);
Char[5].skilllvl = new Array(15,16,17,20,21,24,28,32,36,40,44,47,50,60,65);
Char[5].skillmpused = new Array(6,6,30,32,34,30,33,34,50,50,55,55,60,60,65);
Char[5].skillname = new Array("Air Blade","Lightning","Ice Storm","Eruption","Aqua Mantle","Earthquake","Tangle","Storm","Tornado","Freezer","Lava Flow","Tsunami","Ground Crack","Indignation","Leaf Storm");



Char[6] = new character;
Char[6].Stats = 	{
	HP: 			20,
	MP: 			10,
	maxHP: 		20,
	maxMP: 		10,
	
	Attack: 		7,
	Defense: 		5,
	SpecialAttack: 	5,
	SpecialDefense: 	5,
	
	Evasion:		5,
	Level:		1,
	Speed: 		12
			};
Char[6].faceset = LoadImage("Mariushalf.png");
Char[6].facesetFull = LoadImage("Marius.png");
Char[6].name = "Marius";
Char[6].lastName="Timuel";
Char[6].Spriteset = LoadSpriteset("Lysanderbs.rss");
Char[6].skillbasepower = new Array(25,25,50,60,60,60,60,60,60,90,95,100,110,200,120);
Char[6].skilllvl = new Array(15,16,17,20,21,24,28,32,36,40,44,47,50,60,65);
Char[6].skillmpused = new Array(6,6,30,32,34,30,33,34,50,50,55,55,60,60,65);
Char[6].skillname = new Array("Air Blade","Lightning","Ice Storm","Eruption","Aqua Mantle","Earthquake","Tangle","Storm","Tornado","Freezer","Lava Flow","Tsunami","Ground Crack","Indignation","Leaf Storm");

Char[7] = new character;
Char[7].Stats = 	{
	HP: 			20,
	MP: 			10,
	maxHP: 		20,
	maxMP: 		10,
	
	Attack: 		7,
	Defense: 		5,
	SpecialAttack: 	5,
	SpecialDefense: 	5,
	
	Evasion:		5,
	Level:		1,
	Speed: 		12
			};
Char[7].faceset = LoadImage("Garlandhalf.png");
Char[7].facesetFull = LoadImage("Garland.png");
Char[7].name = "Garland";
Char[7].Spriteset = LoadSpriteset("Lysanderbs.rss");
Char[7].skillbasepower = new Array(25,25,50,60,60,60,60,60,60,90,95,100,110,200,120);
Char[7].skilllvl = new Array(15,16,17,20,21,24,28,32,36,40,44,47,50,60,65);
Char[7].skillmpused = new Array(6,6,30,32,34,30,33,34,50,50,55,55,60,60,65);
Char[7].skillname = new Array("Air Blade","Lightning","Ice Storm","Eruption","Aqua Mantle","Earthquake","Tangle","Storm","Tornado","Freezer","Lava Flow","Tsunami","Ground Crack","Indignation","Leaf Storm");

/*Char[1].activated = true;

Char[3].activated = true;
Char[4].activated = true;
Char[5].activated = true;
Char[6].activated = true;
Char[7].activated = true;
Char[1].party = true;
Char[2].activated = true;
Char[2].party = true;
*/


for(var i=0;i<Char.length;i++)
{
	Char[i].functions = new bCharaFunctions(Char[i].Spriteset);
	Char[i].functions.SetDirection("west");
}



/*
1. Goblin
Lv. 1
HP - 20
MP - 0
Att. - 5
Sp. Att. - 0
Def. - 1
Sp. Def - 2
Acc. - 80
Eva. - 0
Sp. Eva. - 0
Exp. 10
$ - 20
*/



function emotion(who,type)
{
	emonum++;
	
	var person="emo"+emonum;
	
	CreatePerson(person,"emotion.rss",true);
	face(person,type);
	var y=GetPersonY(who);
	var x=GetPersonX(who);
	SetPersonLayer(person,GetNumLayers()-1);
	SetPersonY(person,y-32);
	SetPersonX(person,x-4);
	SetPersonScript(person,SCRIPT_COMMAND_GENERATOR,"QueuePersonCommand(GetCurrentPerson(),COMMAND_ANIMATE,false);");
}

function destroyEmotion(num)
{
	if(!num)
		DestroyPerson("emo"+emonum);
	else
		DestroyPerson("emo"+num);
}

function SFX(who,type)
{
	sfxnum++;
	
	var person="SFX"+sfxnum;
	
	CreatePerson(person,"emotion.rss",true);
	face(person,type);
	var y=GetPersonY(who);
	var x=GetPersonX(who);
	SetPersonLayer(person,GetNumLayers()-1);
	SetPersonY(person,y-32);
	SetPersonX(person,x-4);
	SetPersonScript(person,SCRIPT_COMMAND_GENERATOR,"QueuePersonCommand(GetCurrentPerson(),COMMAND_ANIMATE,false);");
}

function destroySFX(num)
{
	if(!num)
		DestroyPerson("SFX"+sfxnum);
	else
		DestroyPerson("SFX"+num);
}