var lightGray=CreateColor(220,220,220,255);
var talkSpeed=2;

var fps_box=0;
var realtime=0;
var textboxlines=new Array(4);
function talkBox(x,y,text,person,blank,move) 
{
	var w=304;
	var h=font.getHeight()*4;
	var words=new Array();//Holds the words extracted by the split function.
	words=text.split(" ");//splits the text into parts separated by spaces.
	var lines=new Array();//Each element of the array is one line.
	var curLine=0;
	var visiblelines=Floor((h+2)/font.getHeight());
	var offset=0;
	if(person&&person!="")
	{
		lines[0]="-"+person+"-";
		curLine=1;
	}
	if(move==undefined)
		move=false;
	for(var i=0;i<words.length;i++)
	{
		while(words[i]=="\n")
		{
			curLine++;
			i++;
		
		}
		if(!lines[curLine])
			lines[curLine]="";
		if(font.getStringWidth(lines[curLine].concat(" ",words[i]))+6<w)
		{
			if(lines[curLine]=="")
				lines[curLine]=words[i];
			else
				lines[curLine]=lines[curLine].concat(" ",words[i]);
		}
		else
		{
			curLine++;
			if(font.getStringWidth(words[i])+6<w)
				lines[curLine]=words[i];
			else
			{
				for(var j=-1;;j--)
				{
					if(words[i].length+j<1)
						Abort("_textBox: Your box is too narrow to accommodate even a letter!");
					if(j==0)
					{
						if(font.getStringWidth(words[i])+6<w)
						{
							lines[curLine]=words[i];
							break;
						}
					}
					else
					{
						if(font.getStringWidth(words[i].slice(0,j))+6<w)
						{
							lines[curLine]=words[i].slice(0,j);
							curLine++;
							words[i]=words[i].slice(j);
							j=1;
						}
					}
				}
			}
		}
	}
	if (IsMapEngineRunning()) 
		fps_box=GetMapEngineFrameRate();
	else
		fps_box=60;
	textboxlines=new Array(4);
	var workingline=0;
	if(person&&person!="")
		workingline=1;
	var lineoffset=0;
	var charoffset=0;
	var done=false;
	var inkey=GetTalkActivationKey();
	var _startchar=GetTime();
	var _endchar=0;
	var last_time=GetTime();
	var updates=0;
	var frames=0;
	var frame_rate=60;
	var currLine=0;
	////////////////////////////////////////////
	//Function in a function. Used to draw text.
	//Javascript really does shine.
	function draw_text()
	{
		updates+=(GetTime()-last_time)*frame_rate/1000;
		for(;frames<updates;frames++)
		{
			if (IsMapEngineRunning())
				UpdateMapEngine();
		}
		last_time=GetTime();
		if (IsMapEngineRunning())
			RenderMap();
		if(!blank)
			talkImg.blit(x,y-25);
		SetClippingRectangle(0,y-21,320,100);
		for(var i=0;i<textboxlines.length;i++)
		{
			if(textboxlines[i])
			{
				if(person&&person!=""&&i==0&&currLine==0)
					font.setColorMask(lightYellow);
				font.drawText(x+8,y+12*i-14-offset,textboxlines[i]);
				if(person&&person!=""&&i==0&&currLine==0)
					font.setColorMask(white);
			}
		}
		SetClippingRectangle(0,0,320,240);
		FlipScreen();
	}
	//End our function in a function.
	////////////////////////////////////////////
	realtime=GetTime();
	while(!done)
	{
		_endchar=GetTime();
		if(IsKeyPressed(inkey))
			_endchar+=(_endchar-_startchar)*2;
		charoffset+=(_endchar-_startchar)/(100/3);
		if(lines[lineoffset+workingline]==undefined)
			lines[lineoffset+workingline]="";
		if(charoffset>lines[lineoffset+workingline].length+1)
			charoffset=lines[lineoffset+workingline].length+1;
		_startchar=GetTime();
		while(AreKeysLeft()) GetKey();
		for(var i=0;i<workingline;i++)
		{
			textboxlines[i]=lines[lineoffset+i];
		}
		textboxlines[workingline]=lines[lineoffset+workingline].slice(0,charoffset);
		draw_text();
		if(charoffset>lines[lineoffset+workingline].length)
		{
			charoffset=0;
			workingline++;
			if(workingline>=textboxlines.length)
			{
				lineoffset++;
				workingline--;
				if((lineoffset+workingline)>=lines.length)
				{
					while(IsKeyPressed(inkey))
					{
						draw_text();
						if(AreKeysLeft())
							GetKey();
					}
					while(AreKeysLeft()?GetKey()!=inkey:true)
					{
						draw_text();
					}
					_startchar=GetTime();
					done=true;
					continue;
				}
				if(((lineoffset+workingline)%visiblelines)==0)
				{
					while(IsKeyPressed(inkey))
					{
						draw_text();
						if(AreKeysLeft())
							GetKey();
					}
					while(AreKeysLeft()?GetKey()!=inkey:true)
					{
						draw_text();
					}
					_startchar=GetTime();
					currLine=1;
				}
			}
		}
	}
	if(move)
	{
		realtime=GetTime();
		for(var i=0;i<54*4;i++)
		{
			offset+=.5;
			draw_text();
		}
	}
}



function ChoiceBox(x,y,text,person,choice1,choice2,choice3)
{
	talkBox(0,190,text,person,false,false);
	starttime=GetTime()+100;
	ClearKeyQueue();
	var menuChoice=0;
	var maxChoice=2;
	//if choice 3 is undefined...
	if (!choice3)
	{
		maxChoice=1;
		choice3=" ";
	}
	var width;
	if(font.getStringWidth(choice1)>font.getStringWidth(choice2)&&font.getStringWidth(choice1)>font.getStringWidth(choice3))
		width=font.getStringWidth(choice1);
	else if(font.getStringWidth(choice2)>font.getStringWidth(choice1)&&font.getStringWidth(choice2)>font.getStringWidth(choice3))
		width=font.getStringWidth(choice2);
	else if(font.getStringWidth(choice3)>font.getStringWidth(choice1)&&font.getStringWidth(choice3)>font.getStringWidth(choice2))
	width=font.getStringWidth(choice3);
	//Starts function #2.
	var h=font.getHeight()*3;
	var smallDelay=0;
	while(true)
	{
		//draw_text
		for(var i=0;i<(GetTime()-realtime)*fps_box/1000;i++)
		{
			if (IsMapEngineRunning()) 
				UpdateMapEngine();
		}
		if(IsMapEngineRunning())
			RenderMap();
		realtime=GetTime();
		talkImg.blit(x,y-25);
		for(var i=0;i<textboxlines.length;i++)
		{
			if(textboxlines[i])
			{
				if(person&&person!=""&&i==0&&currLine==0)
					font.setColorMask(lightYellow);
				font.drawText(x+8,y+12*i-14-offset,textboxlines[i]);
				if(person&&person!=""&&i==0&&currLine==0)
					font.setColorMask(white);
			}
		}
		for(var i=0;i<3;i++)
		{
			if(IsKeyPressed(KEY_Z)&&starttime<GetTime()&&menuChoice==i)
				return i;
		}
		ws.drawWindow(x+226,y-38,width+2,8+(maxChoice*12));
		font.drawTextBox(x+229,y-28-(maxChoice*12),width+2,12+(maxChoice*12),0,choice1+"\n"+choice2+"\n"+choice3);
		arrow.blit(x+221,y-38+menuChoice*12);
		if(starttime<GetTime())
		{
			if (IsKeyPressed(KEY_DOWN)&&menuChoice<maxChoice)
				menuChoice++;
			if (IsKeyPressed(KEY_UP)&&menuChoice>0)
				menuChoice--;
			starttime=GetTime()+100;
		}
		FlipScreen();
	}
}

function talk(someText,somePerson,top)
{
	if(!top)
		talkBox(0,190,someText,somePerson,false,true);
	else
		talkBox(0,25,someText,somePerson,false,true);
}
function choice(someText,somePerson,someChoice1,someChoice2,someChoice3)
{
	return ChoiceBox(0,190,someText,somePerson,someChoice1,someChoice2,someChoice3);
}
function joinParty(name)
{
	var numInParty=0;
	var i=0;
	for(i=0;i<8;i++)
	{
		if(Char[i].party)
			numInParty++;
	}
	for(i=0;i<8;i++)
	{
		if(Char[i].name==name)
		{
			Char[i].activated=true;
			if(numInParty<4)
				Char[i].party=true;
			talk(name+" has joined the party!");
		}
	}
}



function randomText()
{
	var me=randomText.arguments;
	return me[Floor(Random()*me.length)];
}

function FlipScreenFps()
{
	for(var i=0;i<(GetTime()-realtime)*fps_box/1000;i++)
	{
		if (IsMapEngineRunning()) 
			UpdateMapEngine();
	}
	realtime=GetTime();
	if (IsMapEngineRunning())
		RenderMap();
	FlipScreen();
	
	
}