var g_StillToMove = 0;
var g_MovingInDirection = 0;
var g_AllowMovement = true;
var g_tile_movement = true;
var g_keys_pressed = new Array();

function AddKey(key) {
  g_keys_pressed.push(key);
}

function RemoveKey(key) {
  for (var i = 0; i < g_keys_pressed.length; i++) {
    if (g_keys_pressed[i] == key)
      g_keys_pressed.splice(i, 1);
  }
}

function TileMovement()
{
  if(IsInputAttached()){var name = GetInputPerson();
	  if(g_StillToMove == 0 && run)
		SetPersonSpeed(name,8);
	  else 
		SetPersonSpeed(name,4);
  }
  if(g_AllowMovement && IsInputAttached())
  {
    if (g_keys_pressed.length > 0) {
      if (g_keys_pressed[g_keys_pressed.length - 1] == KEY_UP)    TileMovementUP();
      if (g_keys_pressed[g_keys_pressed.length - 1] == KEY_DOWN)  TileMovementDOWN();
      if (g_keys_pressed[g_keys_pressed.length - 1] == KEY_LEFT)  TileMovementLEFT();
      if (g_keys_pressed[g_keys_pressed.length - 1] == KEY_RIGHT) TileMovementRIGHT();
    }
  }
  if(g_StillToMove > 0)
    UpdateTileMovement();
}


function TileMovementUP()
{
  var name = GetInputPerson();
  if(g_StillToMove <= 0 && IsCommandQueueEmpty(name))
  {
    if (g_MovingInDirection != 0)
      QueuePersonCommand(name, COMMAND_FACE_NORTH,  true);
    
    g_MovingInDirection = 0;
    g_StillToMove = 8;
  }
}

function TileMovementRIGHT()
{
  var name = GetInputPerson();
  if(g_StillToMove <= 0 && IsCommandQueueEmpty(name))
  {
    if (g_MovingInDirection != 2)
      QueuePersonCommand(name, COMMAND_FACE_EAST,  true);
    
    g_MovingInDirection = 2;
    g_StillToMove = 8;
  }
}

function TileMovementDOWN()
{
  var name = GetInputPerson();
  if(g_StillToMove <= 0 && IsCommandQueueEmpty(name))
  {
    if (g_MovingInDirection != 4)
      QueuePersonCommand(name, COMMAND_FACE_SOUTH,  true);
    
    g_MovingInDirection = 4;
    g_StillToMove = 8;
  }
}

function TileMovementLEFT()
{
  var name = GetInputPerson();
  if(g_StillToMove <= 0 && IsCommandQueueEmpty(name))
  {
    if (g_MovingInDirection != 6)
      QueuePersonCommand(name, COMMAND_FACE_WEST,  true);
    
    g_MovingInDirection = 6;
    g_StillToMove = 8;
  }
}

function UpdateTileMovement()
{
  var name = GetInputPerson();
  var spd = GetPersonSpeedX(name);

  if(g_StillToMove > 0 && IsCommandQueueEmpty(name))
  {
    switch(g_MovingInDirection)
    {
      case 0:
       QueuePersonCommand(name, COMMAND_FACE_NORTH, true);
       
       for(i=0;i<spd;i++) QueuePersonCommand(name, COMMAND_MOVE_NORTH, false);
       
       g_StillToMove -= spd;
      break;
      case 2:
       QueuePersonCommand(name, COMMAND_FACE_EAST,  true);
       
       for(i=0;i<spd;i++) QueuePersonCommand(name, COMMAND_MOVE_EAST,  false);
       
       g_StillToMove -= spd;
      break;
      case 4:
       QueuePersonCommand(name, COMMAND_FACE_SOUTH, true);
       
       for(i=0;i<spd;i++) QueuePersonCommand(name, COMMAND_MOVE_SOUTH, false);
       
       g_StillToMove -= spd;
      break;
      case 6:
       QueuePersonCommand(name, COMMAND_FACE_WEST,  true);
       
       for(i=0;i<spd;i++) QueuePersonCommand(name, COMMAND_MOVE_WEST,  false);
       
       g_StillToMove -= spd;
      break;
    }
  }
}
