function warpToWorldMap()
{
	if (Scenes.PapoJoins)
		warp_to_MapSouth.activate();
	else
	{
		DetachInput();
		QueuePersonScript("Zero","face(\"Zero\",\"north\");",false);
		talk("Hey, Zero! Wait for me! I wanna come too!","Papo");
		CreatePerson("Papo","Papo.rss",true);
		SetPersonX("Papo",GetPersonX("Papo")+8);
		SetPersonY("Papo",GetPersonY("Papo")+8);
		var tiles=Floor((GetPersonX("Zero")-GetPersonX("Papo"))*.0625);
		Move("Papo",COMMAND_MOVE_EAST,13,false);
		waitFor("Papo");
		face("Papo","south");
		talk("Alright! Let's go!","Papo","Papo");
		IgnorePersonObstructions("Papo",true);
		Move("Papo",COMMAND_MOVE_SOUTH,9,false);
		QueuePersonScript("Papo","joinParty(\"Papo\");",false);
		QueuePersonScript("Papo","AttachInput(\"Zero\");",false);
		QueuePersonScript("Papo","DestroyPerson(\"Papo\");",false);
		Scenes.PapoJoins=true;
	}

}

function talktoMother()
{
	if(Scenes.TalkToMom)
		warp_to_Atrus_from_zerohouse.activate();
	else
	{
		talk("Maybe I should go talk to my mother first...","Zero");
		Move("Zero",COMMAND_MOVE_NORTH,1);
	}
}

function warpToAtrusRightSide()
{
	if (GetPersonY("Zero") > GetPersonY("Atrus"))
		warp_to_Atrus_from_MapSouth.activate();
	else
		warp_to_Atrus_from_MapNorth.activate();
}






function zoomBlit(image, x, y, scale)
{
	image.transformBlit(x, y, x + (scale * image.width), y, x + (scale * image.width), y + (scale * image.height), x, y + (scale * image.height));
}

function zoomBlitMask(image, x, y, scale, mask)
{
	image.transformBlitMask(x, y, x + (scale * image.width), y, x + (scale * image.width), y + (scale * image.height), x, y + (scale * image.height), mask);
}

/*
*ttn_warp Object
*
*Use this to warp to stuff.
*
*Set it up with its properties,and call the
*activate method to actually use it. This saves
*me from having to write each warp every single
*time.
*
*/
function ttn_warp(x,y,layer,map,trans,dir)
{
	if(this instanceof ttn_warp==false)
		return new ttn_warp(x,y,layer,map,trans,dir);
	this.x=x*16+7;
	this.y=y*16+7;
	this.layer=layer;
	this.map=map;
	this.trans=trans;
	this.dir=dir;
}

ttn_warp.prototype.activate=function()
{
	var msecs=250;
	var time=0;
	var col=CreateColor(0,0,0,255);
	
	var person=Lithonite.GIP;
	gTownDelay=0;
	UpdateMapEngine();
	
	var factor=0;
	//Shove some transition out code here.
	if(this.trans)
	{
		RenderMap();
		var map=GrabImage(0,0,320,240);
		FlipScreen();
		time=GetTime();
		while(GetTime()-time<msecs)
		{
			factor=(GetTime()-time)/msecs+1;
			col.alpha=(GetTime()-time)*255/msecs;
			RenderMap();
			map.zoomBlit(MapToScreenX(0,GetCameraX())-map.width*factor*(MapToScreenX(0,GetCameraX())/GetScreenWidth()),MapToScreenY(0,GetCameraY())-map.height*factor*(MapToScreenY(0,GetCameraY())/GetScreenHeight()),factor);
			ApplyColorMask(col);
			FlipScreen();
		}
	}
	if(this.map)
		ChangeMap(this.map);
	if(this.layer >=0)
		SetPersonLayer(person,this.layer);
	SetPersonX(person,this.x);
	SetPersonY(person,this.y);
	if(this.dir)
		face(person,this.dir);
	//Shove some transition in code here.
	if(this.trans)
	{
		UpdateMapEngine();
		time=GetTime();
		while(GetTime()-time<msecs)
		{
			col.alpha=255-(GetTime()-time)*255/msecs;
			RenderMap();
			ApplyColorMask(col);
			FlipScreen();
		}
	}
	//Happy ending.
	return true;
}