/*Save System made by Rhuan, also credit to
  mcbob/potnoodle, who's marshall.js script
  me the gave me the idea of using a raw file
  as a save file.*/
  
//an array in which all SaveFile Names will be stored
var SaveFileNames  = new Array();
var Count          = 0;
var size_of_header = 0;

/*This function will create the save file,
  if it does not already exsist, if it does
  exsist, it will populate the SaveFileNames
  array by reading in the save files which are
  stored at the start of the file.*/
function CreateSaveFile()
{  
  var SaveCheck        = OpenFile("SaveCheck.dat")
  var save_file_exists = SaveCheck.read("does_save_file_exist", false);
  if (!save_file_exists)
  {
    var SaveFile = OpenRawFile("../Save/SaveFile.dat", true);
    var gap = CreateByteArray(4);
    SaveFile.write(gap);
    WriteData(SaveFileNames, SaveFile);
    var position = SaveFile.getPosition();
    SaveFile.setPosition(0);
    WriteInteger(position, SaveFile);
    SaveFile.close();
    SaveCheck.write("does_save_file_exist", true);
  }
  else
  {
    var SaveFile = OpenRawFile("../Save/SaveFile.dat");
    SaveFile.setPosition(4);
    SaveFileNames = ReadData(SaveFile);
    SaveFile.close();
  }
} 

//this function writes the save file header
function WriteSaveFileHeader(SaveFile)
{
  var gap = CreateByteArray(4);
  SaveFile.write(gap);
  WriteData(SaveFileNames, SaveFile);
  size_of_header = SaveFile.getPosition();
  SaveFile.setPosition(0);
  WriteInteger(size_of_header, SaveFile);
  SaveFile.setPosition(size_of_header);
}

/*This function either creates a save file or deletes one
  you have to provide it with the slot number for the save
  file. The second parameter must be set to true fro saving
  and false for deleting. the function expects you to have
  already added the save file's name onto the SaveFileNames
  array for saving, but for deleting it will remove the name
  itself. Instructions are given within the function for how
  to modify it so that it will save your data.*/
function SaveOrDelete(slot, save_not_delete)
{
  //don't make any changes until the next comment
  var SaveFile  = OpenRawFile("../Save/SaveFile.dat");
  var TempFile  = OpenRawFile("../Save/TempFile.dat", true);
  var size_of_save_file = SaveFile.getSize();
  var save_data = SaveFile.read(size_of_save_file);
  TempFile.write(save_data);
  TempFile.close();
  var temp;
  SaveFile.setPosition(0);
  var size_of_old_header = ReadInteger(SaveFile);
  SaveFile.setPosition(size_of_old_header);
  var current_position;
  for (var i = 0; i < slot; ++i)
  {
    current_position = SaveFile.getPosition();
    temp = ReadInteger(SaveFile);
    SaveFile.setPosition(current_position + temp);
  }
  var slot_position = SaveFile.getPosition();
  SaveFile.setPosition(size_of_old_header);
  var data_before_slot = SaveFile.read(slot_position - size_of_old_header);
  SaveFile.setPosition(slot_position);
  var End = false;
  if(slot_position != SaveFile.getSize())
  {
    temp = ReadInteger(SaveFile);
    SaveFile.setPosition(slot_position + temp);
    var length_to_end = (SaveFile.getSize() - SaveFile.getPosition());
    var data_after_slot = SaveFile.read(length_to_end);
  }
  else
  {
    End = true;
  }
  SaveFile.close();
  var SaveFile = OpenRawFile("../Save/SaveFile.dat", true);
  if(!save_not_delete)
  {
    SaveFileNames.splice(slot, 1);
  }
  WriteSaveFileHeader(SaveFile);
  SaveFile.write(data_before_slot);
  if (save_not_delete)
  {
    slot_position = SaveFile.getPosition();
    Count = 0;
    /*after this comment and before the next one calculate
      all values that need to be calculated before saving
      such as the player's current location etc*/
    var amounts        = new Array();
    var places         = new Array();
    for (var i = 0; i < Items.length; ++i)
    {
      amounts[i] = Items[i].amount;
      places[i]  = Items[i].place;
    }
    location.x         = GetPersonX(GoodGuys[0].name);
    location.y         = GetPersonY(GoodGuys[0].name);
    location.layer     = GetPersonLayer(GoodGuys[0].name);
    location.direction = GetPersonDirection(GoodGuys[0].name);
    /*Leave the next two lines alone*/
    var gap = CreateByteArray(4);
    SaveFile.write(gap);
    /*After this comment and before the next one
      repeatedly call the write data function to
      write all data to file, you need to call it
      once for each data structure you wish to save.*/
    WriteData(GoodGuys, SaveFile);
    WriteData(PlayerSlot, SaveFile);
    WriteData(amounts, SaveFile);
    WriteData(places, SaveFile);
    WriteData(itemplace, SaveFile);
    WriteData(location, SaveFile);
    //Leave the rest of this function precisely the way it is
    Count = -Count;
    WriteData(Count, SaveFile);
    var size_of_data = SaveFile.getPosition() - slot_position;
    SaveFile.setPosition(slot_position);
    WriteInteger(size_of_data, SaveFile);
    if (!End)
    {
      SaveFile.setPosition(slot_position + size_of_data);
      SaveFile.write(data_after_slot);
    }
  }
  else
  {
    if (!End)
    {
      SaveFile.write(data_after_slot);
    }
  }
  SaveFile.close();
}

/*This function restores the contents of the save slot
  slot. Instructions are given for how to modify it in
  order to load your data, if the save slot has been tampered
  with it doesn't restore the data, it returns false, and
  deletes the save slot*/
function RestoreSaveSlot(slot)
{
  //don't make any changes untill after the next save file.
  var SaveFile = OpenRawFile("../Save/SaveFile.dat");
  var current_position;
  for (var i = -1; i < slot; ++i)
  {
    current_position = SaveFile.getPosition();
    temp = ReadInteger(SaveFile);
    SaveFile.setPosition(current_position + temp);
  }
  SaveFile.setPosition(SaveFile.getPosition() + 4);
  var temp_data = new Array();
  Count         = 0;
  /*Each call to ReadData loads one of the data structures
    you saved, you must call it once for every data structure
    you saved, for the time being put all of the loaded data
    into the temp_data array*/
  temp_data[0] = ReadData(SaveFile);
  temp_data[1] = ReadData(SaveFile);
  temp_data[2] = ReadData(SaveFile);
  temp_data[3] = ReadData(SaveFile);
  temp_data[4] = ReadData(SaveFile);
  temp_data[5] = ReadData(SaveFile);
  /*Leave the next saven lines alone*/
  var compare   = ReadData(SaveFile);
  if(Count != 0)
  {
    SaveFile.close();
    SaveOrDelete(slot, false);
    return false;
  }
  /*Now store the contents of the temp data array into the
    variables you want it in.*/
  GoodGuys    = temp_data[0];
  PlayerSlot  = temp_data[1];
  var amounts = temp_data[2];
  var places  = temp_data[3];
  itemplace   = temp_data[4];
  location    = temp_data[5];
  for (var i = 0; i < Items.length; ++i)
  {
    Items[i].amount = amounts[i];
    Items[i].place  = places[i];
  }
  return true;
}

//type codes, these are the hex ascii values of the first letter of the type

var Saved_Object    = 0x6F;
var Saved_Array     = 0x61;
var Saved_String    = 0x73;
var Saved_Integer   = 0x69;
var Saved_Float     = 0x66;
var Saved_Boolean   = 0x62;
var Saved_Undefined = 0x75;

/*This function is called to write data to the file,
  you have to provide the Data and the SaveFile*/
function WriteData(Data, SaveFile)
{
  //Firstly the type of the data needs to be determined
  var type_of_data = typeof(Data);
	
	if (Data instanceof Array)//arrays would otherwise appear as objects
	{
	  type_of_data = "array";
	}
	else  if (Data instanceof String)//it is possible to make a string appear to be an object through defining it in a non-standard way
	{
	  type_of_data = "string";
	}
	else if (Data instanceof Number)//numbers can also be thrown up as objects if they were defined in a non standard way
	{
	  type_of_data = "number";
	}
	switch (type_of_data)//the type of data is know, now to save it appropriately
	{
	  case ("object")://an object can contain multiple pieces of data, and has no length property
	  {
	    WriteType(Saved_Object, SaveFile);//save type
	    WriteObject(Data, SaveFile);//call function to walk through the object, determining length and saving the contents
	    break;
	  }
	  case ("array")://an array can contain multiple pieces of data
	  {
	    WriteType(Saved_Array, SaveFile);//save type
	    WriteInteger(Data.length, SaveFile);//save number of entries in the array
	    WriteArray(Data, SaveFile);//call function to loop through entries saving them
	    break;
	  }
	  case ("string")://a string can be of any length and can contain almost any type of data type
	  {
	    WriteType(Saved_String, SaveFile);//save type
	    WriteInteger(Data.length, SaveFile);//save length
	    SaveFile.write(CreateByteArrayFromString(Data));//save data
	    break;
	  }
	  case ("number"):
	  {
	    Count += Math.floor(Data);
	    if (Math.floor(Data) == Data)//if a number does not have a decimal point, we can save it as an integer, this allows a far bigger number to be saved in the same amount of space
	    {
	      WriteType(Saved_Integer, SaveFile);
	      WriteInteger(Data, SaveFile);
	    }
	    else//if it's not an integer we have to turn it into a string
	    {
	      WriteType(Saved_Float, SaveFile)
	      WriteInteger(new String(Data).length, SaveFile);
	      SaveFile.write(CreateByteArrayFromString(Data));
	    }
	    break;
	  }
	  case ("boolean")://a boolean can have two different values
	  {
	    WriteType(Saved_Boolean, SaveFile);//save type
	    var byte_array_of_booloean = CreateByteArray(1)
	    if (Data)//determine value
	    {
	      byte_array_of_booloean[0] = 1;
	    }
	    else
	    {
	      byte_array_of_booloean[0] = 0;
	    }
	    SaveFile.write(byte_array_of_booloean);//save data
	    break;
	  }
	  case ("undefined")://data of type undefined can only have one possible value
	  {
	    WriteType(Saved_Undefined, SaveFile);//save type
	    break;
	  }
	  default:
	  {
	    Abort("I am sorry, you have supplied my save\nscript with an unidentified data type.\n~Rhuan\n");
	  }
	}
}

function WriteType (Type, SaveFile)//save the type of data
{
  var type = CreateByteArray(1)
  type[0] = Type;
  SaveFile.write(type);
}

function WriteArray(array, SaveFile)
{
  for (var i = 0; i < array.length; ++i)//loop through the array saving the data
  {
    WriteData(array[i], SaveFile);
  }
}

function WriteObject(object, SaveFile)
{
  var length_of_object = 0;
  for (var i in object)//walk through the object to determine it's length
  {
    ++length_of_object;
  }
  WriteInteger(length_of_object, SaveFile);//save the length
  for (i in object)//walk through the object saving the entries and their names
  {
    WriteData(i, SaveFile);
    WriteData(object[i], SaveFile);
  }
}

function WriteInteger(Integer, SaveFile)//this function makes a number into a hex integer and saves it
{
  var array_of_integer      = new Array();
  array_of_integer[0]       = (Integer & 0xff000000) >> 24;
  array_of_integer[1]       = (Integer & 0x00ff0000) >> 16;
  array_of_integer[2]       = (Integer & 0x0000ff00) >> 8;
  array_of_integer[3]       = (Integer & 0x0000000ff);
  var byte_array_of_integer = CreateByteArray(4);
  byte_array_of_integer[0]  = array_of_integer[0];
  byte_array_of_integer[1]  = array_of_integer[1];
  byte_array_of_integer[2]  = array_of_integer[2];
  byte_array_of_integer[3]  = array_of_integer[3];
  SaveFile.write(byte_array_of_integer);
}

/*This function is called to read data from the file
you need to set the right location in the file before
you call it, you have to supply it with the SaveFile object.
When loading an object, include the name of the function used to
declare the object as a second parameter, this is optional, but
will allow you to use the instanceof opperand on the object after
you've loaded it*/
function ReadData(SaveFile)
{
  var type_of_data = SaveFile.read(1)[0];//lets read the type
  switch (type_of_data)
  {
    case (Saved_Object)://Objects contain multiple data fields, so a sepperate function is called to walk through them loading the data
    {
      return ReadObject(SaveFile);
    }
    case (Saved_Array)://Arrays contain multiple data fields, so a sepperate function is called to walk through them loading the data
    {
      return ReadArray(SaveFile);
    }
    case (Saved_String)://Strings can be of any length
    {
      var length_of_string = ReadInteger(SaveFile);//Read in the length
      return CreateStringFromByteArray(SaveFile.read(length_of_string));//Read in the string
    }
    case (Saved_Integer)://As the code for loading an integer is called repeatedly it is in a sepperate function
    {
      var integer = ReadInteger(SaveFile);
      Count += integer;
      return integer;
    }
    case (Saved_Float)://A floating point number is treated just like a string
    {
      var length_of_float = ReadInteger(SaveFile);
      var Float = new Number(CreateStringFromByteArray(SaveFile.read(length_of_float)));
      Count += (Math.floor(Float));
      return Float;
    }
    case (Saved_Boolean)://A boolean can have two different values
    {
      var Data = SaveFile.read(1)[0];//read in the data
      if (Data == 1)//now, is it true or false...
      {
        return true;
      }
      else
      {
        return false;
      }
    }
    case (Saved_Undefined)://Variables of type undefined can only have one value so...
    {
      return undefined;
    }
    default:
    {
      Abort("Unrecognised data type identifier, either\nthe position to read from is not correct\nthis is a corrupt save file, or it was \nnot created with my SaveSystem\n ~Rhuan\n");
    }
  }
}

function ReadInteger(SaveFile)//Read in an integer
{
  var byte_array_of_integer = SaveFile.read(4);
  var integer               = 0;
  integer += byte_array_of_integer[0] << 24;
  integer += byte_array_of_integer[1] << 16;
  integer += byte_array_of_integer[2] << 8;
  integer += byte_array_of_integer[3];
  return integer;
}

function ReadArray(SaveFile)//Read in an array
{
  var length_of_array = ReadInteger(SaveFile);//Find out how long the array is
  var array = new Array();
  for(var i = 0; i < length_of_array; ++i)//Loop through the array loading the data
  {
    array[i] = ReadData(SaveFile);
  }
  return array;
}

function ReadObject(SaveFile)//Read in an Object
{
  var length_of_object = ReadInteger(SaveFile);//determine how long the object is
  var object = new Object;
  for (var i = 0; i < length_of_object; ++i)//Walk throught the object loading the data
  {
    var name_of_entry     = ReadData(SaveFile);
    object[name_of_entry] = ReadData(SaveFile);
  }
  return object;
}