// ************************************************************

/*
 * Variables
 *
 * Global variables for... global use. Yay.
 *
 */
EvaluateScript("journal.js");


var journal = new Journal();
//var battle = new Battle();

//colors!
var lightBlue = 		CreateColor(0,128,255,128);
var redMenu = 		CreateColor(255,128,128,255);
var greenMenu = 		CreateColor(0,196,0,255);
var blueMenu = 		CreateColor(128,128,255,255);
var cyanMenu = 		CreateColor(128,196,196,255);
var yellowMenu = 		CreateColor(220,220,0,255);
var yellow = 		CreateColor(255,255,0,255);
var yellowBattle = 	CreateColor(255,220,0,255);
var lightYellow = 	CreateColor(255,255,185,255);
var red = 			CreateColor(255,0,0,255);
var blue = 			CreateColor(0,0,255,255);
var white = 		CreateColor(255,255,255,255);
var black = 		CreateColor(0,0,0);
var darkGray=		CreateColor(75,75,75);
var gray=			CreateColor(128,128,128);
var crimson=		CreateColor(153,0,0);
var golden=			CreateColor(255,204,0);

var veryLightYellow = 	CreateColor(255,255,220,255);
var veryLightRed = 	CreateColor(255,220,220,255);
var veryLightCyan = 	CreateColor(220,255,255,255);
var veryLightGreen = 	CreateColor(220,255,220,255);

//math functions
var Floor = Math.floor;
var Random = Math.random;
var Ceil = Math.ceil;
var Round = Math.round;
var Pi = Math.PI;
var Sin = Math.sin;
var Pow = Math.pow;
var Sqrt = Math.sqrt;

//var Scene=-2;
var Scene=4;
var emonum=0;

var font=	LoadFont("ToP.rfn");
var font2=	LoadFont("small.rfn");
var bfont=	LoadFont("battle.rfn");

var gTownDelay=0;
var gTownText="";

var music=		LoadSound("hooh.mid",true);
var crisis=		LoadSound("crisis.ogg");



var playweather=false;
var weathereffect=LoadAnimation("rain.mng");
var weatherwait=0;
var ws=LoadWindowStyle("menu.rws");

var puzzleArray=new Array(3);
for(var i=0;i<3;i++)
{
	puzzleArray[i]=new Array(3);
}

var selectRect=		LoadImage("selection.png");
var emptySphere=		LoadImage("emptySphere.png");
var fullSphere=		LoadImage("fullSphere.png");
var newImg=			LoadImage("new.png");
var arrowdown=		LoadImage("arrowdown.png");
var arrowup=		LoadImage("arrowup.png");
var hand=			LoadImage("hand.png");
var quote=			LoadImage("quote.png");
var glass=			LoadImage("glass.png");
var newgameImg=		LoadImage("newgame.png");
var continueImg=		LoadImage("continue.png");
var exitImg=		LoadImage("exit.png");
var sphere=			LoadImage("Sphere.png");
var title=			LoadImage("Title.png");
var titlebg=		LoadImage("titlebg.png");

var menuImg;
var talkImg;
var townImg;
var puzzleImg;

// GLOBAL VARIABLES FOR THE PLAYER.

var g_Gold = 0;
var g_TimeStart = GetTime();
var g_TimePlayed = 0; //3600000 = 1 hour
var g_NumSpheres=1;
var nextLvExp=new Array(99);

for(var i=0;i<100;i++)
{
	nextLvExp[i]=Math.pow(i,3)+10*i;
}


// ************************************************************

/* 
 * Warps
 * 
 * Once the warps here are created, they may be
 *  called anywhere where a script can be called,
 *  essentially making warps reusable.
 * 
 */
 
var Martel;
 
var warp_to_ZerosHouseDownstairs = new ttn_warp(10, 1, 1, "ZerosHouseDownstairs.rmp", true,"south");
var warp_to_ZerosHouseDownstairs2 = new ttn_warp(11, 1, 1, "ZerosHouseDownstairs.rmp", true,"south");

var warp_to_ZerosHouseDownstairs_from_Atrus = new ttn_warp(4, 13, 1, "ZerosHouseDownstairs.rmp", true,"north");

var warp_to_ZerosHouseUpstairs = new ttn_warp(9, 6, 1, "ZerosHouseUpstairs.rmp", true,"north");
var warp_to_ZerosHouseUpstairs2 = new ttn_warp(10, 6, 1, "ZerosHouseUpstairs.rmp", true,"north");

var warp_to_MapSouth = new ttn_warp(57,48, 1, "worldmap.rmp", true,"south");
var warp_to_MapNorth = new ttn_warp(57,45, 1, "worldmap.rmp", true,"south");

var warp_to_Atrus_from_zerohouse = new ttn_warp(12, 47, 1, "Atrus.rmp", true,"south");
var warp_to_AfainasHouseDownstairs = new ttn_warp(6,17,1,"AfainasHouseDownstairs.rmp",true,"north");
var warp_to_Atrus_from_MapNorth = new ttn_warp(39,4,1,"Atrus.rmp",true,"south");
var warp_to_Atrus_from_MapSouth = new ttn_warp(37,60,1,"Atrus.rmp",true,"north");


var warp_to_AtreanForest_from_Map = new ttn_warp(1,8,1,"Atrean Forest.rmp",true,"east");

var warp_to_House1_from_Atrus = new ttn_warp(14,13,1,"AtrusHouse1.rmp",true,"north");
var warp_to_House2_from_Atrus = new ttn_warp(6,17,1,"AtrusHouse2.rmp",true,"north");
var warp_to_Inn_from_Atrus = new ttn_warp(17,16,1,"AtrusInn.rmp",true,"north");
var warp_to_Map_from_AtreanForest = new ttn_warp(57,49,1,"worldmap.rmp",true,"north");

var warp_to_Atrus_from_AfainasHouse = new ttn_warp(61,20,1,"Atrus.rmp",true,"south");

var warp_to_Atrus_from_AtrusHouse1 = new ttn_warp(44,48,1,"Atrus.rmp",true,"south");
var warp_to_Atrus_from_AtrusHouse2 = new ttn_warp(63,45,1,"Atrus.rmp",true,"south");

var warp_to_Figuera_from_Map = new ttn_warp(24,48,1,"Figuera.rmp",true,"north");


