EvaluateSystemScript("audio.js");
EvaluateSystemScript("time.js");
EvaluateSystemScript("clock.js");
EvaluateScript("warp.js");
EvaluateScript("save.js");
EvaluateScript("intro.js");
EvaluateScript("movement.js");
EvaluateScript("characternew.js");
EvaluateScript("battlenew.js");
EvaluateScript("cutscene.js");
EvaluateScript("Menu.js");
EvaluateScript("talking.js");
EvaluateScript("maps.js");
EvaluateScript("script.js");
EvaluateScript("globals.js");
EvaluateScript("camera.js");
EvaluateScript("journal.js");
EvaluateScript("lithonite.js");
EvaluateScript("Skills.js");
EvaluateScript("bCharaFunctions.js");
EvaluateScript("Scenes.js");

var MainChar="Zero";

const DEFAULT_SPEED=2;

function size()
{
	width=GetScreenWidth();
	height=GetScreenHeight();
}

var d = new size;

//puzzle#1
/*	puzzleArray[0][0]=0;
	puzzleArray[1][0]=2;
	puzzleArray[2][0]=3;
	puzzleArray[0][1]=1;
	puzzleArray[1][1]=0;
	puzzleArray[2][1]=4;
	puzzleArray[0][2]=0;
	puzzleArray[1][2]=1;
	puzzleArray[2][2]=6;
*/

//puzzle#2
/*	puzzleArray[0][0]=5;
	puzzleArray[1][0]=4;
	puzzleArray[2][0]=0;
	puzzleArray[0][1]=0;
	puzzleArray[1][1]=3;
	puzzleArray[2][1]=0;
	puzzleArray[0][2]=2;
	puzzleArray[1][2]=6;
	puzzleArray[2][2]=4;
*/

//"Beavers were proven by the great Callum Au to be academically and mentally more intelligent than their feeble English teacher counterparts, so they were trained as teachers and slowly and surely, English beavers replaced English teachers."
function game()
{
	RequireScript("movementlitho.js");
	ws.drawWindow(4,4,312,67);
	talkImg=GrabImage(0,0,320,75);
	ws.drawWindow(4,4,312,20);
	townImg=GrabImage(0,0,320,28);
	Rectangle(0,0,320,240,black);
	
	//0=leftright,1=updown,2=topleft,3=topright,4=bottomleft,5=bottomright
	puzzleArray[0][0]=5;
	puzzleArray[1][0]=4;
	puzzleArray[2][0]=0;
	puzzleArray[0][1]=0;
	puzzleArray[1][1]=3;
	puzzleArray[2][1]=0;
	puzzleArray[0][2]=2;
	puzzleArray[1][2]=6;
	puzzleArray[2][2]=4;
	//puzzle(1,2,0);
	music.play(true);
	SetTalkActivationKey(KEY_Z);
	FlipScreen();
	//intro();
	music.stop();
	//introScript();
	//journal.newJournalEntry("Downfall of Atrus","That Saiken guy...! I'll KILL him! The first time I see him... But he had that sphere on his left hand, just like me... Does that mean... I am one of them?");
	CreatePerson(MainChar,"Zero.rss",false);
	Lithonite.SaveDirections(MainChar);
	AttachCamera("Zero");
	//SetPersonScript("Zero",SCRIPT_COMMAND_GENERATOR,"SetPersonFrame('Zero',0);");
	SetUpdateScript("UpdateScript();");
	SetRenderScript("RenderScript();");
	BindKey(KEY_ESCAPE,"t();","t();");
	BindKey(KEY_SPACE,"MainMenu();","t();");
	MapEngine("ZerosHouseUpstairs.rmp",60);
}

function t(){}

function face(p,d)
{
	SetPersonDirection(p,d);
}

function UpdateScript()
{
	Movement_Update();
}

function weather()
{
	if(playweather)
	{
		weathereffect.drawFrame(0,0);
		if(GetTime()>weatherwait+60)
		{
			weatherwait=GetTime();
			weathereffect.readNextFrame();
		}
	}
}

function ClearKeyQueue() 
{
	while(IsKeyPressed(KEY_Z)){}
	while(AreKeysLeft()) 
		GetKey();
}

function waitm(ms)
{
	var starttime=GetTime();
	while(GetTime()<starttime+ms) 
	{
		FlipScreenFps();
		if(IsMapEngineRunning())
			RenderMap();
	}
}

function SetTownText(text)
{
	gTownText=text;
	gTownDelay=200;
	gTownColor.alpha=0;
	gTownFade="i";
	gTownTime=GetTime();
}

var gTownColor=CreateColor(255,255,255,0);
var atrusText=LoadImage("Atrus.png");
var gTownImg="";
var gTownFade="i";
var gTownTime=0;
var gTownAlpha = 0;
/*function RenderTownText()
{
	var w=font.getStringWidth(gTownText);
	if(gTownDelay>0)
	{
		ws.drawWindow(155-w*0.5,62,w+10,7);
		font.drawText(160-w*0.5,60,gTownText);
		gTownDelay--;
	}
}*/
function RenderTownText()
{
	
	gTownImg = (gTownText=="Atrus") ? gTownImg=atrusText : gTownImg="";
	if(gTownFade=="i")
		gTownAlpha = (GetTime() - gTownTime) / 750 * 255;
	else if(gTownFade=="o")
		gTownAlpha = 255 - (GetTime() - gTownTime) / 750 * 255;
	if(gTownAlpha>=255 && gTownFade == "i")
	{
		gTownAlpha = 255;
		gTownFade = "p";
		gTownTime = GetTime();
	}
	else if(gTownFade == "p")
	{
		if(gTownTime+2000<=GetTime())
		{
			gTownFade = "o";
			gTownTime = GetTime();
		}
	}
	else if(gTownAlpha<=0 && gTownFade == "o")
	{
		gTownAlpha = 0;
		gTownFade = "n";
	}
	gTownColor.alpha = gTownAlpha;
	if(gTownImg!="")
		gTownImg.blitMask(0,0,gTownColor);
}
function RenderScript()
{
	Render_Update();
	weather();
	RenderTownText();
}
