//0=leftright,1=updown,2=topleft,3=topright,4=bottomleft,5=bottomright
var solY1=1;
var solY2=1;
function puzzle(numSolutions,someY1,someY2)
{
	var solutions=1;
	if(numSolutions)
		solutions=numSolutions;
	if(someY1)
		solY1=someY1;
	if(solY2)
		solY2=someY2;
	var cx=0
	var cy=0;
	var replace=0;
	var blockimg=new Array(LoadImage("leftright.PNG"),LoadImage("updown.PNG"),LoadImage("topleft.PNG"),LoadImage("topright.PNG"),LoadImage("bottomleft.PNG"),LoadImage("bottomright.PNG"),LoadImage("blankblock.PNG"));
	//var chosenblock=LoadImage("chosenblock.PNG");
	var time=GetTime()+100;
	var solved=false;
	while(true)
	{
		Rectangle(0,0,320,240,black);
		for(var y=0;y<3;y++)
		{
			for(var x=0;x<3;x++)
			{
				blockimg[puzzleArray[x][y]].blit(65+x*70,15+y*70);
			}
		}
		Rectangle(45,49+solY1*70,20,2,lightYellow);
		Rectangle(275,49+solY2*70,20,2,lightYellow);
		cx=determineX();
		cy=determineY();
		//chosenblock.blit(65+cx*70,15+cy*70);
		if(time<GetTime())
		{
			if(IsKeyPressed(KEY_UP)&&cy>0)
			{
				replace=puzzleArray[cx][cy-1];
				puzzleArray[cx][cy-1]=puzzleArray[cx][cy];
				puzzleArray[cx][cy]=replace;
			}
			else if(IsKeyPressed(KEY_DOWN)&&cy<2)
			{
				replace=puzzleArray[cx][cy+1];
				puzzleArray[cx][cy+1]=puzzleArray[cx][cy];
				puzzleArray[cx][cy]=replace;
			}
			else if(IsKeyPressed(KEY_LEFT)&&cx>0)
			{
				replace=puzzleArray[cx-1][cy];
				puzzleArray[cx-1][cy]=puzzleArray[cx][cy];
				puzzleArray[cx][cy]=replace;
			}
			else if(IsKeyPressed(KEY_RIGHT)&&cx<2)
			{
				replace=puzzleArray[cx+1][cy];
				puzzleArray[cx+1][cy]=puzzleArray[cx][cy];
				puzzleArray[cx][cy]=replace;
			}
			else if(IsKeyPressed(KEY_ENTER))
			{
				if(checkSolutions(solutions)==0)
				{
					solved=true;
					return;
				}
			}
			else if(IsKeyPressed(KEY_X))
				return;
			time=GetTime()+100;
		}
		battleFlipScreen();
	}
	if(solved)
		return 0;
	else
		return -1;
}
function checkSolutions(numSolutions)
{
	puzzleImg=GrabImage(0,0,320,240);
	var count=0;
	var x=0;
	var y=solY1;
	var dir="right";
	var done=false;
	var solved=false;
	for(var i=0;i<19;i++)
	{
		puzzleImg.blit(0,0);
		Rectangle(45,49+solY1*70,2+i,2,cyanMenu);
		puzzleImg=GrabImage(0,0,320,240);
		battleFlipScreen();
	}
	//0=leftright,1=updown,2=topleft,3=topright,4=bottomleft,5=bottomright
	while(!done)
	{
		if(numSolutions==1&&(x==3&&y==solY2))
		{
			done=true;
			solved=true;
		}
		else if(numSolutions==2&&(x==3&&y==solY2))
		{
				done=true;
				solved=true;
		}
		else if(puzzleArray[x][y]==0&&dir=="right")
		{
			goRight(x,y);
			x++;
		}
		else if(puzzleArray[x][y]==0&&dir=="left")
		{
			goLeft(x,y);
			x--;
		}
		else if(puzzleArray[x][y]==1&&dir=="up")
		{
			goUp(x,y);
			y--;
		}
		else if(puzzleArray[x][y]==1&&dir=="down")
		{
			goDown(x,y);
			y++;
		}
		else if(puzzleArray[x][y]==2&&dir=="right")
		{
			goRightUp(x,y);
			y--;
			dir="up";
		}
		else if(puzzleArray[x][y]==3&&dir=="down")
		{
			goDownRight(x,y);
			x++;
			dir="right";
		}
		else if(puzzleArray[x][y]==3&&dir=="left")
		{
			goLeftUp(x,y);
			y--;
			dir="up";
		}
		else if(puzzleArray[x][y]==4&&dir=="right")
		{
			goRightDown(x,y);
			y++;
			dir="down";
		}
		else if(puzzleArray[x][y]==4&&dir=="up")
		{
			goUpLeft(x,y);
			x--;
			dir="left";
		}
		else if(puzzleArray[x][y]==5&&dir=="up")
		{
			goUpRight(x,y);
			x++;
			dir="right";
		}
		else
			done=true;
		
	}
	if(solved)
	{
		for(var i=0;i<19;i++)
		{
			puzzleImg.blit(0,0);
			Rectangle(275,49+solY2*70,2+i,2,cyanMenu);
			puzzleImg=GrabImage(0,0,320,240);
			battleFlipScreen();
		}
		return 0;
	}
	return -1;
}
function goRight(x,y,half)
{
	var num=69;
	for(var i=0;i<num;i++)
	{
		puzzleImg.blit(0,0);
		Rectangle(65+x*70,49+y*70,2+i,2,cyanMenu);
		puzzleImg=GrabImage(0,0,320,240);
		battleFlipScreen();
	}
}
function goLeft(x,y)
{
	var num=69;
	for(var i=0;i<num;i++)
	{
		puzzleImg.blit(0,0);
		Rectangle(65+x*70,49+y*70,-i,2,cyanMenu);
		puzzleImg=GrabImage(0,0,320,240);
		battleFlipScreen();
	}
}
function goUp(x,y)
{
	var num=69;
	for(var i=num-1;i>=0;i--)
	{
		puzzleImg.blit(0,0);
		Rectangle(99+x*70,85+y*70,2,2+i,cyanMenu);
		puzzleImg=GrabImage(0,0,320,240);
		battleFlipScreen();
	}
}
function goDown(x,y)
{
	var num=69;
	for(var i=0;i<num;i++)
	{
		puzzleImg.blit(0,0);
		Rectangle(99+x*70,15+y*70,2,2+i,cyanMenu);
		puzzleImg=GrabImage(0,0,320,240);
		battleFlipScreen();
	}
}
function goRightUp(x,y)
{
	var num=35;
	for(var i=0;i<num;i++)
	{
		puzzleImg.blit(0,0);
		Rectangle(65+x*70,49+y*70,2+i,2,cyanMenu);
		puzzleImg=GrabImage(0,0,320,240);
		battleFlipScreen();
	}
	for(var i=0;i<num;i++)
	{
		puzzleImg.blit(0,0);
		Rectangle(99+x*70,49+y*70,2,-i,cyanMenu);
		puzzleImg=GrabImage(0,0,320,240);
		battleFlipScreen();
	}
}
function goUpLeft(x,y)
{
	var num=35;
	for(var i=0;i<num;i++)
	{
		puzzleImg.blit(0,0);
		Rectangle(99+x*70,85+y*70,2,-i,cyanMenu);
		battleFlipScreen();
	}
	puzzleImg.blit(0,0);
	Rectangle(99+x*70,85+y*70,2,-35,cyanMenu);
	puzzleImg=GrabImage(0,0,320,240);
	for(var i=0;i<num;i++)
	{
		puzzleImg.blit(0,0);
		Rectangle(101+x*70,49+y*70,-i,2,cyanMenu);
		battleFlipScreen();
	}
	puzzleImg.blit(0,0);
	Rectangle(101+x*70,49+y*70,-35,2,cyanMenu);
	puzzleImg=GrabImage(0,0,320,240);
}
function goLeftUp(x,y)
{
	var num=35;
	for(var i=0;i<num+2;i++)
	{
		puzzleImg.blit(0,0);
		Rectangle(136+x*70,49+y*70,-i,2,cyanMenu);
		battleFlipScreen();
	}
	puzzleImg.blit(0,0);
	Rectangle(136+x*70,49+y*70,-37,2,cyanMenu);
	puzzleImg=GrabImage(0,0,320,240);
	for(var i=0;i<num;i++)
	{
		puzzleImg.blit(0,0);
		Rectangle(99+x*70,50+y*70,2,-i,cyanMenu);
		battleFlipScreen();
	}
	puzzleImg.blit(0,0);
	Rectangle(99+x*70,50+y*70,2,-35,cyanMenu);
	puzzleImg=GrabImage(0,0,320,240);
}
function goUpRight(x,y)
{
	var num=35;
	for(var i=0;i<num;i++)
	{
		puzzleImg.blit(0,0);
		Rectangle(99+x*70,85+y*70,2,-i,cyanMenu);
		puzzleImg=GrabImage(0,0,320,240);
		battleFlipScreen();
	}
	for(var i=0;i<num;i++)
	{
		puzzleImg.blit(0,0);
		Rectangle(99+x*70,49+y*70,2+i,2,cyanMenu);
		puzzleImg=GrabImage(0,0,320,240);
		battleFlipScreen();
	}
}
function goRightDown(x,y)
{
	var num=35;
	for(var i=0;i<num;i++)
	{
		puzzleImg.blit(0,0);
		Rectangle(65+x*70,49+y*70,2+i,2,cyanMenu);
		puzzleImg=GrabImage(0,0,320,240);
		battleFlipScreen();
	}
	for(var i=0;i<num;i++)
	{
		puzzleImg.blit(0,0);
		Rectangle(99+x*70,50+y*70,2,2+i,cyanMenu);
		puzzleImg=GrabImage(0,0,320,240);
		battleFlipScreen();
	}
}
function goDownRight(x,y)
{
	var num=35;
	for(var i=0;i<num;i++)
	{
		puzzleImg.blit(0,0);
		Rectangle(99+x*70,15+y*70,2,2+i,cyanMenu);
		puzzleImg=GrabImage(0,0,320,240);
		battleFlipScreen();
	}
	for(var i=0;i<num;i++)
	{
		puzzleImg.blit(0,0);
		Rectangle(99+x*70,49+y*70,2+i,2,cyanMenu);
		puzzleImg=GrabImage(0,0,320,240);
		battleFlipScreen();
	}

}
function determineX()
{
	for(var y=0;y<3;y++)
	{
		for(var x=0;x<3;x++)
		{
			if(puzzleArray[x][y]==6)
				return x;
		}
	}
}

function determineY()
{
	for(var y=0;y<3;y++)
	{
		for(var x=0;x<3;x++)
		{
			if(puzzleArray[x][y]==6)
				return y;
		}
	}
}